/*
                     XRazzle!, an XScreenSaver hack

                         hacked by Bradley Bell
                    e-mail: maximill@u.washington.edu

     The original Razzle! code is (C) Copyright 1995 Richard L. Smith

            THIS PROGRAM GENERATES REAL-TIME 3-D STEREOGRAMS!

Permission to use, copy, modify, distribute and sell this software and it's
documentation for any purpose is hereby granted without fee. 
I make no representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.
*/

/*
xrazzle 0.1.2:
  made window resizeable.
xrazzle 0.1.1:
  fixed some bugs.
  new resources/c.l.o.'s:
    cycle: True/False - cycle colors!
    nCycle: how often to cycle colors (number of redraws to wait)
xrazzle 0.1.0:
  rewrote and reorganized large chunks of code...
  this will be purely an X hack now.
  Also added several new resources and command-line options.
*/

#include <stdio.h>
#include <stdlib.h>
#include "screenhack.h"

#define MAX_NCOLORS 256
#define MIN_NCOLORS 64

void razzle(Display *dpy, Window window);

void fill_palette(Display *dpy, int paletteType);

void choose_values(Display *dpy, Window window);
void make_stereo(void);

void draw_bouncy_box1(Display *dpy, Window window);
void draw_bouncy_box2(Display *dpy, Window window);
void draw_lines(Display *dpy, Window window);
void draw_centered_box(Display *dpy, Window window);
void draw_Xs(Display *dpy, Window window);
void draw_twirlers(Display *dpy, Window window);
void draw_double_Xs(Display *dpy, Window window);
void draw_4pt_star(Display *dpy, Window window);
void draw_6pth_star(Display *dpy, Window window);
void draw_6ptv_star(Display *dpy, Window window);
void draw_double_box(Display *dpy, Window window);
void draw_8pt_star(Display *dpy, Window window);
void draw_slant6_star(Display *dpy, Window window);
void draw_5pt_star(Display *dpy, Window window);
void draw_pinwheel(Display *dpy, Window window);
void draw_box_Xs(Display *dpy, Window window);
void draw_criss_cross(Display *dpy, Window window);
void draw_4Xs(Display *dpy, Window window);
void draw_aline(Display *dpy, Window window);
void draw_asym1(Display *dpy, Window window);
void draw_asym2(Display *dpy, Window window);
void draw_asym3(Display *dpy, Window window);
void draw_asym4(Display *dpy, Window window);
void draw_asym5(Display *dpy, Window window);
void draw_asym6(Display *dpy, Window window);
void draw_asym7(Display *dpy, Window window);
void draw_asym8(Display *dpy, Window window);
void draw_asym9(Display *dpy, Window window);
void draw_asym10(Display *dpy, Window window);
void draw_asym11(Display *dpy, Window window);
void draw_asym12(Display *dpy, Window window);
void draw_sym1(Display *dpy, Window window);
void draw_sym2(Display *dpy, Window window);
void draw_sym3(Display *dpy, Window window);
void draw_sym4(Display *dpy, Window window);
void draw_sym5(Display *dpy, Window window);
void draw_sym6(Display *dpy, Window window);
void draw_sym7(Display *dpy, Window window);

int whichmax  = 38; /* increase by one if you add your own drawing function. */
int drawFunc = 0;  /* Should equal case statement calling your drawing     */
		    /* function for testing or otherwise equal 0 */
int maxMap   = 6;
int whichMap = 0;

/* xs1-ys5 are cordinates for the drawline statements */
int xs1, xs2, xs3, xs4, xs5, xs6, xs7, xs8, xs9;
int ys1, ys2, ys3, ys4, ys5, ys6, ys7, ys8, ys9;

int c, acr;

int width, height;
int xoffset[15], yoffset[10];
int maxboxsize=3, x1=10, x2, x3=10, x4=10, y_1=10, y2, y3=10, y4=10;
int n3=0, boxwidth, boxheight;
int xflag=1, xflag1=1, xflag2=1, yflag=1, yflag1=1, yflag2=1;
int whichDrawFunc, cflag;
int xfseed=1, yfseed=1, xf1seed=2, yf1seed=2, xf2seed=1, yf2seed=1;
int cmax, c_div=2, howmanyx, howmanyy;  
float aspect;

static GC draw_gc;
static unsigned int default_fg_pixel;

Colormap cmap;
Visual *visual;
static XColor colors[MAX_NCOLORS];
static int nColors = 0;

Bool writable;
int delay, nCycle;

char *progclass = "Razzle";

char *defaults [] = {
    "*drawFunc:    0",
    "*nMax:        1000",
    "*nColors:     256",
    "*delay:       500",
    "*cycle:       False",
    "*nCycle:      5",
    "*paletteType: 0",
    "*hCells:      0",
    "*vCells:      0",
    "*stereo:      True",
    0
};

XrmOptionDescRec options [] = {
    { "-drawFunc",     ".drawFunc",    XrmoptionSepArg, 0 },
    { "-nMax",         ".nMax",        XrmoptionSepArg, 0 },
    { "-nColors",      ".nColors",     XrmoptionSepArg, 0 },
    { "-cycle",        ".cycle",       XrmoptionNoArg,  "True" },
    { "-no-cycle",     ".cycle",       XrmoptionNoArg,  "False" },
    { "-delay",        ".delay",       XrmoptionSepArg, 0 },
    { "-nCycle",       ".nCycle",      XrmoptionSepArg, 0 },
    { "-paletteType",  ".paletteType", XrmoptionSepArg, 0 },
    { "-hCells",       ".hCells",      XrmoptionSepArg, 0 },
    { "-vCells",       ".vCells",      XrmoptionSepArg, 0 },
    { "-stereo",       ".stereo",      XrmoptionNoArg,  "True" },
    { "-no-stereo",    ".stereo",      XrmoptionNoArg,  "False" },
    { 0, 0, 0, 0 }
};

void screenhack(Display* dpy, Window window)
{
    XGCValues gcv;
    
    gcv.foreground = default_fg_pixel;
    draw_gc = XCreateGC(dpy, window, GCForeground, &gcv);

    drawFunc = get_integer_resource ("drawFunc", "Integer");
    if ((drawFunc > whichmax) || (drawFunc < 1)) drawFunc = 0;

    whichMap = get_integer_resource ("paletteType", "Integer");
    if ((whichMap > maxMap) || (whichMap < 1)) whichMap = 0;

    nColors = get_integer_resource ("nColors", "Integer");
    if (nColors > MAX_NCOLORS) nColors = MAX_NCOLORS;
    if (nColors < MIN_NCOLORS) nColors = MIN_NCOLORS;

    writable = get_boolean_resource ("cycle", "Boolean");
    
    delay = get_integer_resource ("delay", "Integer");
    if (delay < 0) delay=0;
    
    nCycle = get_integer_resource ("nCycle", "Integer");
    if (nCycle < 1) nCycle=1;
    
    razzle(dpy, window);
}

void razzle(Display *dpy, Window window)
{
    int n, n1;
    int nMax = get_integer_resource ("nMax", "Integer");
    XWindowAttributes xgwa;
    
    xoffset[0]=0;
    yoffset[0]=0;
    n3=nMax;

    while (1) {
	XGetWindowAttributes(dpy, window, &xgwa);
	cmap = xgwa.colormap;
	width = xgwa.width;
	height = xgwa.height;
	visual = xgwa.visual;


	if (n3>=nMax) choose_values(dpy, window); /* do a new pattern */
	++n3;
	if (acr<100) c_div=1; /* c_div limits the depth of the image */
	if (acr>200) c_div=3;
	aspect=((float)height/width);
	
	if (get_boolean_resource ("stereo", "Boolean"))
	    make_stereo();

	if (x1 <= *xoffset) {
	    xflag=xfseed; /* check if x cord is out of bounds */
	    x1=*xoffset;
	}
	if (x2 >= *(xoffset+1)) {
	    xflag=-xfseed;
	    x1=*(xoffset+1)-boxwidth;
	}
	if (x3 <= *xoffset)  xflag1=xf1seed; 
	if (x3 >= *(xoffset+1))  xflag1=-xf1seed;  
	if (x4 <= *xoffset)  xflag2=xf2seed;
	if (x4 >= *(xoffset+1))  xflag2=-xf2seed;
	x1+=xflag;                     /* update x cords */
	x3+=xflag1;
	x4+=xflag2;
	x2=x1+boxwidth;
	if (y_1 <= *yoffset) {
	    yflag=yfseed; /* check if y cord is out of bounds */
	    y_1=*yoffset;
	}
	if (y2 >= *(yoffset+1)) {
	    yflag=-yfseed;
	    y_1=*(yoffset+1)-boxheight;
	}
	if (y3 <= *yoffset)  yflag1=yf1seed;
	if (y3 >= *(yoffset+1))  yflag1=-yf1seed;
	if (y4 <= *yoffset)  yflag2=yf2seed;
	if (y4 >= *(yoffset+1))  yflag2=-yf2seed;
	y_1+=yflag;                     /* update y cords */
	y3+=yflag1;
	y4+=yflag2;
	y2=y_1+boxheight;   
	c+=cflag;                      /* choose color to draw with */
	if ((c == 1) || (c == cmax))  cflag=-cflag; /* go up and down */
	XSetForeground(dpy, draw_gc, colors[c].pixel);
	for (n1=0; n1<howmanyy; n1++) {
	    for (n=0; n<howmanyx; n++) {
		xs1=x1+*(xoffset+n);  /* determine each cell's drawing cords */
		xs2=xs1+boxwidth;
		xs4=*(xoffset+n+1)-x1;
		xs3=xs4-boxwidth;
		xs5=(xs1+xs4)/2;
		xs6=x3+*(xoffset+n);
		xs7=x4+*(xoffset+n);
		xs8=*(xoffset+n+1)-x3;
		xs9=*(xoffset+n+1)-x4;
		ys1=y_1+*(yoffset+n1);
		ys2=ys1+boxheight;
		ys4=*(yoffset+n1+1)-y_1;
		ys3=ys4-boxheight;
		ys5=(ys1+ys4)/2;
		ys6=y3+*(yoffset+n1);
		ys7=y4+*(yoffset+n1);
		ys8=*(yoffset+n1+1)-y3;
		ys9=*(yoffset+n1+1)-y4;
		switch (whichDrawFunc) {
		case 1:
		    draw_bouncy_box1(dpy, window);
		    break;
		case 2:
		    draw_bouncy_box2(dpy, window);
		    break;
		case 3:
		    draw_lines(dpy, window);
		    break;
		case 4:
		    draw_centered_box(dpy, window);
		    break;
		case 5:
		    draw_Xs(dpy, window);
		    break;
		case 6:
		    draw_twirlers(dpy, window);
		    break;
		case 7:
		    draw_double_Xs(dpy, window);
		    break;
		case 8:
		    draw_4pt_star(dpy, window);
		    break;
		case 9:
		    draw_6pth_star(dpy, window);
		    break;
		case 10:
		    draw_6ptv_star(dpy, window);
		    break;
		case 11:
		    draw_double_box(dpy, window);
		    break;
		case 12:
		    draw_8pt_star(dpy, window);
		    break;
		case 13:
		    draw_slant6_star(dpy, window);
		    break; 
		case 14:
		    draw_5pt_star(dpy, window); 
		    break;
		case 15:
		    draw_pinwheel(dpy, window);
		    break;
		case 16:
		    draw_box_Xs(dpy, window);
		    break;
		case 17:
		    draw_criss_cross(dpy, window);
		    break;
		case 18:
		    draw_4Xs(dpy, window);
		    break;
		case 19:
		    draw_aline(dpy, window);
		    break;
		case 20:
		    draw_asym1(dpy, window);
		    break;
		case 21:
		    draw_asym2(dpy, window);
		    break;
		case 22:
		    draw_asym3(dpy, window);
		    break;
		case 23:
		    draw_asym4(dpy, window);
		    break;
		case 24:
		    draw_asym5(dpy, window);
		    break;
		case 25:
		    draw_asym6(dpy, window);
		    break;
		case 26:
		    draw_asym7(dpy, window);
		    break; 
		case 27:
		    draw_asym8(dpy, window);
		    break;
		case 28:
		    draw_asym9(dpy, window);
		    break;
		case 29:
		    draw_asym10(dpy, window);
		    break;
		case 30:
		    draw_asym11(dpy, window);
		    break;
		case 31:
		    draw_asym12(dpy, window);
		    break;
		case 32:
		    draw_sym1(dpy, window);
		    break;
		case 33:
		    draw_sym2(dpy, window);
		    break;
		case 34:
		    draw_sym3(dpy, window);
		    break;
		case 35:
		    draw_sym4(dpy, window);
		    break;
		case 36:
		    draw_sym5(dpy, window);
		    break;
		case 37:
		    draw_sym6(dpy, window);
		    break;
		case 38:
		    draw_sym7(dpy, window);
		    break;
		default:
		    printf("no thingy chosen?");
		}
	    }
	}
	usleep(delay);
	if (writable && !(n3 % nCycle)) /*if nCycle goes evenly into n3*/
	    rotate_colors(dpy, cmap, colors, nColors, 1);
    }
}

/**************** function to do color spreads, rands, etc *****************/

void fill_palette(Display *dpy, int paletteType)
{
    static allocatedColors = 0;
    
    if (allocatedColors)
	free_colors(dpy, cmap, colors, allocatedColors);
    switch(paletteType){
    case 1:
	make_smooth_colormap(dpy, visual, cmap, colors, &nColors,
			     True, &writable, True);
	break;
    case 2:
	make_uniform_colormap(dpy, visual, cmap, colors, &nColors,
			      True, &writable, True);
	break;
    case 3:
	make_random_colormap(dpy, visual, cmap, colors, &nColors,
			     False, True, &writable, True);
	break;
    case 4:
	make_color_ramp(dpy, cmap,
			random() % 360, frand(1.0), frand(0.8) + 0.2,
			random() % 360, frand(1.0), frand(0.8) + 0.2,
			colors, &nColors, False, True, writable);
	break;
    case 5:
	make_color_ramp(dpy, cmap,
			random() % 360, frand(1.0), frand(0.8) + 0.2,
			random() % 360, frand(1.0), frand(0.8) + 0.2,
			colors, &nColors, True, True, writable);
	break;
    case 6:
	make_color_loop(dpy, cmap,
			random() % 360, frand(1.0), frand(0.8) + 0.2,
			random() % 360, frand(1.0), frand(0.8) + 0.2,
			random() % 360, frand(1.0), frand(0.8) + 0.2,
			colors, &nColors, True, writable);
	break;
    }	
    allocatedColors=nColors;
    if (!allocatedColors) {
	printf("Could not allocate any colors. Try using -install\n");
	abort();
    }
}  

/***************** Choose a bunch of values to draw with ***************/

void choose_values(Display *dpy, Window window) {
    int n;
    int mapChoice;
    int hCells = get_integer_resource ("hCells", "Integer");
    int vCells = get_integer_resource ("vCells", "Integer");

    if (whichMap == 0) mapChoice = (random() % 6)+1;
    else mapChoice = whichMap;
    fill_palette(dpy, mapChoice);
    acr = nColors - 1;

    if (hCells > 0)
	howmanyx = hCells;
    else
	howmanyx = (random() % 8)+4; /* number of horiz cells on screen */
    if (vCells > 0)
	howmanyy = vCells;
    else
	howmanyy = (random() % 7)+1; /* number of vert cells on screen */

#ifdef DEBUG
    printf("howmanyx: %d, howmanyy: %d\n", howmanyx, howmanyy);
#endif

    xoffset[0]=0;       /* x-yoffset[] holds cell corner cords */
    yoffset[0]=0;

    /* fill x-yoffset[] with cords */
    for (n=1; n<=howmanyx; n++) xoffset[n]=(width/howmanyx)*n;
    for (n=1; n<=howmanyy; n++) yoffset[n]=(height/howmanyy)*n;
    boxwidth=(random() % xoffset[1])/maxboxsize+1;
    boxheight=(random() % yoffset[1])/maxboxsize+1;

    x1=(random() % (xoffset[1]-boxwidth)); 
    y_1=(random() % (yoffset[1]-boxheight)); 
    x3=(random() % xoffset[1]);
    x4=(random() % xoffset[1]);
    y3=(random() % yoffset[1]);
    y4=(random() % yoffset[1]);
    XClearWindow(dpy, window);
    cmax=(random() % (acr/2))+(acr/3); 
    c=1;
    cflag=1;  
    n3=0; 
    if ( drawFunc==0) whichDrawFunc=(random() % whichmax)+1; 
    else whichDrawFunc=drawFunc;
    if ((random() % 5) == 0) xfseed=2; else xfseed=1;
    if ((random() % 5) == 0) yfseed=2; else yfseed=1;
    if ((random() % 8) == 0) xf1seed=2; else xf1seed=1;
    if ((random() % 8) == 0) yf1seed=2; else yf1seed=1;
    if ((random() % 8) == 0) xf2seed=2; else xf2seed=1;
    if ((random() % 8) == 0) yf2seed=2; else yf2seed=1;
#ifdef DEBUG
    printf("whichDrawFunc: %d\n", whichDrawFunc);
#endif

}

/************************* StereoGram function ****************************/

void make_stereo(void) {
    int n, wh, hh, w, h;
    wh=width - c/c_div; /* The secret of the sauce.....I'm not going to tell! */
    hh=height-((int)((c/c_div) * aspect)+.5);
    for(n=0; n<=howmanyx; n++) *(xoffset+n)=(wh/howmanyx)*n;
    for(n=0; n<=howmanyy; n++) *(yoffset+n)=(hh/howmanyy)*n;
    w=(width-*(xoffset+howmanyx))/2;  /* hint: center the cells */
    h=(height-*(yoffset+howmanyy))/2; 
    for(n=0; n<=howmanyx; n++) *(xoffset+n)+=w;
    for(n=0; n<=howmanyy; n++) *(yoffset+n)+=h;
}

/*****************  Pattern drawing functions follow *****************/
/*                                                                   */
/* Roll-your-own layout:        xs1 xs2 xs5 xs3 xs4                  */
/*                          ys1  *   *   *   *   *                   */
/*      Just                ys2  *   *   *   *   *                   */
/* Connect the dots!        ys5  *   *   *   *   *                   */
/*                          ys3  *   *   *   *   *                   */
/*                          ys4  *   *   *   *   *                   */
/*                                                                   */
/* The above cords are related and move "together" and are built     */
/* from x1, x2, y_1 and y2.                                           */
/* The cords are symeterical, xs5 is always the center of the cell,  */
/* xs4 is the "complement" of xs1 and xs3 is the "complement" of xs2 */
/*                                                                   */
/*                           xs1 xs6 xs7 xs9 xs8 xs4                 */
/*                       ys4  *   *   *   *   *   *                  */
/*                       ys8  *   *   *   *   *   *                  */
/*                       ys9  *   *   *   *   *   *                  */
/*                       ys7  *   *   *   *   *   *                  */
/*                       ys6  *   *   *   *   *   *                  */
/*                       ys1  *   *   *   *   *   *                  */
/*                                                                   */
/* These cords are also symetrical in that xs9 is the complement of  */
/* xs7 but xs1, xs6, xs7 all move "independently" of each other.     */
/* They are built from x1, x3, x4, y_1, y3 and y4.                    */
/* You can use them with the first set of cords.                     */
/*                                                                   */  
/* To add your own drawing function:  First add the function name to */
/* the proto-type list at the top of this file, then increase        */
/* whichmax by one.  Go to the big switch statement in main and add  */
/* a case statement calling your function.  Go to the bottom of the  */
/* file and add your drawing function using the above cords as your  */
/* guide. Make drawFunc equal your calling case statment to test.   */
/* Otherwise drawFunc should equal 0.                               */
/*                                                                   */
/*********************************************************************/
     
void draw_bouncy_box1(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs1,ys2); /* (1) draw boxes */
    XDrawLine(dpy, window, draw_gc, xs1,ys2,xs2,ys2);
    XDrawLine(dpy, window, draw_gc, xs2,ys2,xs2,ys1);
    XDrawLine(dpy, window, draw_gc, xs2,ys1,xs1,ys1);

    XDrawLine(dpy, window, draw_gc, xs1,ys3,xs1,ys4);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs2,ys4);
    XDrawLine(dpy, window, draw_gc, xs2,ys4,xs2,ys3);
    XDrawLine(dpy, window, draw_gc, xs2,ys3,xs1,ys3);

    XDrawLine(dpy, window, draw_gc, xs3,ys1,xs3,ys2);
    XDrawLine(dpy, window, draw_gc, xs3,ys2,xs4,ys2);
    XDrawLine(dpy, window, draw_gc, xs4,ys2,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs3,ys1);

    XDrawLine(dpy, window, draw_gc, xs3,ys3,xs3,ys4);
    XDrawLine(dpy, window, draw_gc, xs3,ys4,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs4,ys3);
    XDrawLine(dpy, window, draw_gc, xs4,ys3,xs3,ys3);
}

void draw_bouncy_box2(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs1,ys2); /* (2) draw 2 color boxes */
    XDrawLine(dpy, window, draw_gc, xs1,ys2,xs2,ys2);
    XDrawLine(dpy, window, draw_gc, xs2,ys2,xs2,ys1);
    XDrawLine(dpy, window, draw_gc, xs2,ys1,xs1,ys1);

    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys3,xs1,ys4);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs2,ys4);
    XDrawLine(dpy, window, draw_gc, xs2,ys4,xs2,ys3);
    XDrawLine(dpy, window, draw_gc, xs2,ys3,xs1,ys3);

    XDrawLine(dpy, window, draw_gc, xs3,ys1,xs3,ys2);
    XDrawLine(dpy, window, draw_gc, xs3,ys2,xs4,ys2);
    XDrawLine(dpy, window, draw_gc, xs4,ys2,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs3,ys1);

    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs3,ys3,xs3,ys4);
    XDrawLine(dpy, window, draw_gc, xs3,ys4,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs4,ys3);
    XDrawLine(dpy, window, draw_gc, xs4,ys3,xs3,ys3);
}

void draw_lines(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs2,ys2); /* (3) lines */
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs2,ys3);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs3,ys2);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs3,ys3);
}

void draw_centered_box(Display *dpy, Window window) {
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs7,ys8,xs7,ys6); /* (4) centered boxes */
    XDrawLine(dpy, window, draw_gc, xs9,ys8,xs9,ys6);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs6,ys9,xs8,ys9);
    XDrawLine(dpy, window, draw_gc, xs6,ys7,xs8,ys7);
}

void draw_Xs(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs6,ys8,xs8,ys6); /* (5) X's */
    XDrawLine(dpy, window, draw_gc, xs8,ys8,xs6,ys6);
}

void draw_twirlers(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys2,xs3,ys4); /* (6) twirlers */
    XDrawLine(dpy, window, draw_gc, xs3,ys4,xs4,ys3);
    XDrawLine(dpy, window, draw_gc, xs4,ys3,xs2,ys1);
    XDrawLine(dpy, window, draw_gc, xs2,ys1,xs1,ys2);
}

void draw_double_Xs(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys2,xs3,ys4); /* (7) double X's */
    XDrawLine(dpy, window, draw_gc, xs3,ys4,xs4,ys3);
    XDrawLine(dpy, window, draw_gc, xs4,ys3,xs2,ys1);
    XDrawLine(dpy, window, draw_gc, xs2,ys1,xs1,ys2);

    XDrawLine(dpy, window, draw_gc, xs2,ys4,xs4,ys2);
    XDrawLine(dpy, window, draw_gc, xs4,ys2,xs3,ys1);
    XDrawLine(dpy, window, draw_gc, xs3,ys1,xs1,ys3);
    XDrawLine(dpy, window, draw_gc, xs1,ys3,xs2,ys4);
}

void draw_4pt_star(Display *dpy, Window window) { 
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs5,ys2); /* (8) 4 point stars */
    XDrawLine(dpy, window, draw_gc, xs5,ys2,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs3,ys5);
    XDrawLine(dpy, window, draw_gc, xs3,ys5,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs5,ys3);
    XDrawLine(dpy, window, draw_gc, xs5,ys3,xs1,ys4);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs2,ys5);
    XDrawLine(dpy, window, draw_gc, xs2,ys5,xs1,ys1);
}

void draw_6pth_star(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys2,xs4,ys2); /* (9) 6 point stars horz */
    XDrawLine(dpy, window, draw_gc, xs4,ys2,xs5,ys4);
    XDrawLine(dpy, window, draw_gc, xs5,ys4,xs1,ys2);
    XDrawLine(dpy, window, draw_gc, xs4,ys3,xs1,ys3);
    XDrawLine(dpy, window, draw_gc, xs1,ys3,xs5,ys1);
    XDrawLine(dpy, window, draw_gc, xs5,ys1,xs4,ys3);
}

void draw_6ptv_star(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys5,xs3,ys4); /* (10) 6 point stars vert */
    XDrawLine(dpy, window, draw_gc, xs3,ys4,xs3,ys1);
    XDrawLine(dpy, window, draw_gc, xs3,ys1,xs1,ys5);
    XDrawLine(dpy, window, draw_gc, xs2,ys4,xs4,ys5);
    XDrawLine(dpy, window, draw_gc, xs4,ys5,xs2,ys1);
    XDrawLine(dpy, window, draw_gc, xs2,ys1,xs2,ys4);
}

void draw_double_box(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs7,ys8,xs9,ys8); /* (11) doubled centered boxes */
    XDrawLine(dpy, window, draw_gc, xs9,ys8,xs9,ys6);
    XDrawLine(dpy, window, draw_gc, xs9,ys6,xs7,ys6);
    XDrawLine(dpy, window, draw_gc, xs7,ys6,xs7,ys8);

    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs6,ys9,xs8,ys9);
    XDrawLine(dpy, window, draw_gc, xs8,ys9,xs8,ys7);
    XDrawLine(dpy, window, draw_gc, xs8,ys7,xs6,ys7);
    XDrawLine(dpy, window, draw_gc, xs6,ys7,xs6,ys9);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
}

void draw_8pt_star(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs4,ys5); /* (12) 8 point star */
    XDrawLine(dpy, window, draw_gc, xs4,ys5,xs1,ys1);
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs5,ys4);
    XDrawLine(dpy, window, draw_gc, xs5,ys4,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs1,ys5);
    XDrawLine(dpy, window, draw_gc, xs1,ys5,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs5,ys1);
    XDrawLine(dpy, window, draw_gc, xs5,ys1,xs1,ys4);
}

void draw_slant6_star(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs4,ys5); /* (13) another 6 pointed star */
    XDrawLine(dpy, window, draw_gc, xs4,ys5,xs5,ys1);
    XDrawLine(dpy, window, draw_gc, xs5,ys1,xs1,ys4);
    XDrawLine(dpy, window, draw_gc, xs1,ys5,xs5,ys4);
    XDrawLine(dpy, window, draw_gc, xs5,ys4,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs1,ys5);
}

void draw_5pt_star(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs5,ys2); /* (14) 5 pointed star */
    XDrawLine(dpy, window, draw_gc, xs5,ys2,xs4,ys1); /* snow angels ? */
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs1,ys4);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs5,ys1);
    XDrawLine(dpy, window, draw_gc, xs5,ys1,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs1,ys1);
}

void draw_pinwheel(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs2,ys1); /* (15) pin wheel */
    XDrawLine(dpy, window, draw_gc, xs2,ys1,xs3,ys4);
    XDrawLine(dpy, window, draw_gc, xs3,ys4,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs4,ys3);
    XDrawLine(dpy, window, draw_gc, xs4,ys3,xs1,ys2);
    XDrawLine(dpy, window, draw_gc, xs1,ys2,xs1,ys1);

    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs3,ys1,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs4,ys2);
    XDrawLine(dpy, window, draw_gc, xs4,ys2,xs1,ys3);
    XDrawLine(dpy, window, draw_gc, xs1,ys3,xs1,ys4);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs2,ys4);
    XDrawLine(dpy, window, draw_gc, xs2,ys4,xs3,ys1);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
}

void draw_box_Xs(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs6,ys8,xs8,ys6); /* (16) centered boxes with X's */
    XDrawLine(dpy, window, draw_gc, xs6,ys6,xs8,ys8);

    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs1,ys1);
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs1,ys4);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
}

void draw_criss_cross(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs2,ys2); /* (17) crossed lines */
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs2,ys3);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs3,ys2);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs3,ys3);

    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys2,xs2,ys1);
    XDrawLine(dpy, window, draw_gc, xs3,ys1,xs4,ys2);
    XDrawLine(dpy, window, draw_gc, xs1,ys3,xs2,ys4);
    XDrawLine(dpy, window, draw_gc, xs3,ys4,xs4,ys3);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
}

void draw_4Xs(Display *dpy, Window window) {
    XDrawLine(dpy, window, draw_gc, xs2,ys1,xs3,ys4); /* (18) */
    XDrawLine(dpy, window, draw_gc, xs1,ys3,xs4,ys2);
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys2,xs4,ys3);
    XDrawLine(dpy, window, draw_gc, xs2,ys4,xs3,ys1);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
}

void draw_aline(Display *dpy, Window window) {
    XDrawPoint(dpy, window, draw_gc, xs1,ys1); /* (19) */
    XDrawPoint(dpy, window, draw_gc, xs2,ys2);
    XDrawPoint(dpy, window, draw_gc, xs1,ys2);
    XDrawPoint(dpy, window, draw_gc, xs2,ys1);

    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawPoint(dpy, window, draw_gc, xs1,ys4);
    XDrawPoint(dpy, window, draw_gc, xs2,ys3);
    XDrawPoint(dpy, window, draw_gc, xs1,ys3);
    XDrawPoint(dpy, window, draw_gc, xs2,ys4);

    XDrawPoint(dpy, window, draw_gc, xs4,ys1);
    XDrawPoint(dpy, window, draw_gc, xs3,ys2);
    XDrawPoint(dpy, window, draw_gc, xs4,ys2);
    XDrawPoint(dpy, window, draw_gc, xs3,ys1);

    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawPoint(dpy, window, draw_gc, xs4,ys4);
    XDrawPoint(dpy, window, draw_gc, xs3,ys3);
    XDrawPoint(dpy, window, draw_gc, xs4,ys3);
    XDrawPoint(dpy, window, draw_gc, xs3,ys4);
}

void draw_asym1(Display *dpy, Window window) {  /* (20) bouncing x */
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs7,ys7,xs6,ys6);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs7,ys6,xs6,ys7);
}  

void draw_asym2(Display *dpy, Window window) {   /* (21) bouncing line */
    XDrawLine(dpy, window, draw_gc, xs7,ys7,xs6,ys6);
}

void draw_asym3(Display *dpy, Window window) {  /* (22) bouncing box */
    XDrawLine(dpy, window, draw_gc, xs7,ys7,xs6,ys7);
    XDrawLine(dpy, window, draw_gc, xs7,ys6,xs6,ys6);
    XDrawLine(dpy, window, draw_gc, xs7,ys7,xs7,ys6);
    XDrawLine(dpy, window, draw_gc, xs6,ys7,xs6,ys6);
}

void draw_asym4(Display *dpy, Window window) {  /* (23) two lines connected */
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs6,ys6);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs6,ys6,xs7,ys7);
}

void draw_asym5(Display *dpy, Window window) {
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);           /* (24) */
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs6,ys6);
    XDrawLine(dpy, window, draw_gc, xs6,ys6,xs4,ys4);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs6,ys6);
    XDrawLine(dpy, window, draw_gc, xs6,ys6,xs4,ys1);
}

void draw_asym6(Display *dpy, Window window) {
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);          /* (25) */
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs1,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs4,ys1);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs5,ys6);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs5,ys6);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs5,ys6);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs5,ys6);
}

void draw_asym7(Display *dpy, Window window) {
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);           /* (26) */
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs2,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs3,ys4);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs2,ys4,xs5,ys6);
    XDrawLine(dpy, window, draw_gc, xs3,ys4,xs5,ys6);
}

void draw_asym8(Display *dpy, Window window) {     /* (27) triangle */
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs6,ys6);
    XDrawLine(dpy, window, draw_gc, xs6,ys6,xs7,ys7);
    XDrawLine(dpy, window, draw_gc, xs7,ys7,xs1,ys1);
}

void draw_asym9(Display *dpy, Window window) {
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);          /* (28) */
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs5,ys6);
    XDrawLine(dpy, window, draw_gc, xs5,ys6,xs4,ys1);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs5,ys7);
    XDrawLine(dpy, window, draw_gc, xs5,ys7,xs4,ys1);
}

void draw_asym10(Display *dpy, Window window) {  /* (29) 4 bouncing boxes */
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs6,ys4,xs7,ys4);
    XDrawLine(dpy, window, draw_gc, xs7,ys4,xs7,ys8);
    XDrawLine(dpy, window, draw_gc, xs7,ys8,xs6,ys8);
    XDrawLine(dpy, window, draw_gc, xs6,ys8,xs6,ys4);

    XDrawLine(dpy, window, draw_gc, xs9,ys6,xs8,ys6);
    XDrawLine(dpy, window, draw_gc, xs8,ys6,xs8,ys1);
    XDrawLine(dpy, window, draw_gc, xs8,ys1,xs9,ys1);
    XDrawLine(dpy, window, draw_gc, xs9,ys1,xs9,ys6);

    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs8,ys7,xs4,ys7);
    XDrawLine(dpy, window, draw_gc, xs4,ys7,xs4,ys6);
    XDrawLine(dpy, window, draw_gc, xs4,ys6,xs8,ys6);
    XDrawLine(dpy, window, draw_gc, xs8,ys6,xs8,ys7);

    XDrawLine(dpy, window, draw_gc, xs1,ys8,xs6,ys8);
    XDrawLine(dpy, window, draw_gc, xs6,ys8,xs6,ys9);
    XDrawLine(dpy, window, draw_gc, xs6,ys9,xs1,ys9);
    XDrawLine(dpy, window, draw_gc, xs1,ys9,xs1,ys8);
}

void draw_asym11(Display *dpy, Window window) { /* (30) 4 right angle triangles changed! symetrical */
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs6,ys4);
    XDrawLine(dpy, window, draw_gc, xs6,ys4,xs1,ys8);
    XDrawLine(dpy, window, draw_gc, xs1,ys8,xs1,ys4);

    XDrawLine(dpy, window, draw_gc, xs8,ys1,xs4,ys6);
    XDrawLine(dpy, window, draw_gc, xs4,ys6,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs4,ys1,xs8,ys1);

    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs8,ys4,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs4,ys8);
    XDrawLine(dpy, window, draw_gc, xs4,ys8,xs8,ys4);

    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs6,ys1);
    XDrawLine(dpy, window, draw_gc, xs6,ys1,xs1,ys6);
    XDrawLine(dpy, window, draw_gc, xs1,ys6,xs1,ys1);
} 

void draw_asym12(Display *dpy, Window window) {  /* (31) 4 sided closed figure */
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs6,ys6);
    XDrawLine(dpy, window, draw_gc, xs6,ys6,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs4,ys4,xs7,ys7);
    XDrawLine(dpy, window, draw_gc, xs7,ys7,xs1,ys1);
}

void draw_sym1(Display *dpy, Window window) {  /* (32) more symetrical patterns */
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs6,ys8);
    XDrawLine(dpy, window, draw_gc, xs8,ys6,xs4,ys1);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs6,ys6);
    XDrawLine(dpy, window, draw_gc, xs8,ys8,xs4,ys4);
}

void draw_sym2(Display *dpy, Window window) {
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);     /* (33) */
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs6,ys8);
    XDrawLine(dpy, window, draw_gc, xs8,ys6,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs6,ys6);
    XDrawLine(dpy, window, draw_gc, xs8,ys8,xs4,ys4);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs7,ys9);
    XDrawLine(dpy, window, draw_gc, xs9,ys7,xs4,ys1);
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs7,ys7);
    XDrawLine(dpy, window, draw_gc, xs9,ys9,xs4,ys4);
}

void draw_sym3(Display *dpy, Window window) {  /* (34) mo boxes */
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys8,xs6,ys4);
    XDrawLine(dpy, window, draw_gc, xs8,ys4,xs4,ys8);
    XDrawLine(dpy, window, draw_gc, xs1,ys6,xs6,ys1);
    XDrawLine(dpy, window, draw_gc, xs8,ys1,xs4,ys6);

    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys8,xs4,ys8);
    XDrawLine(dpy, window, draw_gc, xs8,ys4,xs8,ys1);
    XDrawLine(dpy, window, draw_gc, xs6,ys4,xs6,ys1);
    XDrawLine(dpy, window, draw_gc, xs1,ys6,xs4,ys6);

}

void draw_sym4(Display *dpy, Window window) {
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);       /* (35) */
    XDrawLine(dpy, window, draw_gc, xs1,ys4,xs6,ys8);
    XDrawLine(dpy, window, draw_gc, xs8,ys8,xs4,ys4);
    XDrawLine(dpy, window, draw_gc, xs1,ys1,xs6,ys6);
    XDrawLine(dpy, window, draw_gc, xs8,ys6,xs4,ys1);
 
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys8,xs6,ys4);
    XDrawLine(dpy, window, draw_gc, xs8,ys4,xs4,ys8);
    XDrawLine(dpy, window, draw_gc, xs1,ys6,xs6,ys1);
    XDrawLine(dpy, window, draw_gc, xs8,ys1,xs4,ys6);
}

void draw_sym5(Display *dpy, Window window) {
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);          /* (36) */
    XDrawLine(dpy, window, draw_gc, xs1,ys8,xs6,ys4);
    XDrawLine(dpy, window, draw_gc, xs6,ys4,xs4,ys6);
    XDrawLine(dpy, window, draw_gc, xs4,ys6,xs8,ys1);
    XDrawLine(dpy, window, draw_gc, xs8,ys1,xs1,ys8);

    XDrawLine(dpy, window, draw_gc, xs1,ys6,xs8,ys4);
    XDrawLine(dpy, window, draw_gc, xs8,ys4,xs4,ys8);
    XDrawLine(dpy, window, draw_gc, xs4,ys8,xs6,ys1);
    XDrawLine(dpy, window, draw_gc, xs6,ys1,xs1,ys6);

    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs7,ys8,xs9,ys8);
    XDrawLine(dpy, window, draw_gc, xs9,ys8,xs9,ys6);
    XDrawLine(dpy, window, draw_gc, xs9,ys6,xs7,ys6);
    XDrawLine(dpy, window, draw_gc, xs7,ys6,xs7,ys8);

    XDrawLine(dpy, window, draw_gc, xs6,ys9,xs8,ys9);
    XDrawLine(dpy, window, draw_gc, xs8,ys9,xs8,ys7);
    XDrawLine(dpy, window, draw_gc, xs8,ys7,xs6,ys7);
    XDrawLine(dpy, window, draw_gc, xs6,ys7,xs6,ys9);
}

void draw_sym6(Display *dpy, Window window) {  /* (37) zig-zag */
    XDrawLine(dpy, window, draw_gc, xs1,ys8,xs6,ys4);
    XDrawLine(dpy, window, draw_gc, xs6,ys4,xs7,ys8);
    XDrawLine(dpy, window, draw_gc, xs7,ys8,xs6,ys9);
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);
    XDrawLine(dpy, window, draw_gc, xs6,ys9,xs7,ys7);
    XDrawLine(dpy, window, draw_gc, xs7,ys7,xs9,ys9);
    XDrawLine(dpy, window, draw_gc, xs9,ys9,xs8,ys7);
    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs8,ys7,xs9,ys6);
    XDrawLine(dpy, window, draw_gc, xs9,ys6,xs8,ys1);
    XDrawLine(dpy, window, draw_gc, xs8,ys1,xs4,ys6);
}

void draw_sym7(Display *dpy, Window window) {
    XSetForeground(dpy, draw_gc, colors[acr-c].pixel);         /* (38) */
    XDrawLine(dpy, window, draw_gc, xs1,ys8,xs6,ys4);
    XDrawLine(dpy, window, draw_gc, xs6,ys4,xs7,ys9);
    XDrawLine(dpy, window, draw_gc, xs7,ys9,xs1,ys8);

    XDrawLine(dpy, window, draw_gc, xs9,ys7,xs4,ys6);
    XDrawLine(dpy, window, draw_gc, xs4,ys6,xs8,ys1);
    XDrawLine(dpy, window, draw_gc, xs8,ys1,xs9,ys7);

    XSetForeground(dpy, draw_gc, colors[c].pixel);
    XDrawLine(dpy, window, draw_gc, xs1,ys6,xs7,ys7);
    XDrawLine(dpy, window, draw_gc, xs7,ys7,xs6,ys1);
    XDrawLine(dpy, window, draw_gc, xs6,ys1,xs1,ys6);

    XDrawLine(dpy, window, draw_gc, xs9,ys9,xs8,ys4);
    XDrawLine(dpy, window, draw_gc, xs8,ys4,xs4,ys8);
    XDrawLine(dpy, window, draw_gc, xs4,ys8,xs9,ys9);
}
